﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Diagnostics;
using Infragistics.Windows.Helpers;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using Infragistics.Windows.DockManager;
using Infragistics.Windows.Extensions;
using System.Windows.Interactivity;

namespace TestWindowsApp
{
	/// <summary>
	/// Interaction logic for Window_DockBinding.xaml
	/// </summary>
	public partial class Window_DockBinding : Window
	{
		#region Constructor
		public Window_DockBinding()
		{
			InitializeComponent();
            this.DataContext = new Window_DockBindingViewModel();
		} 
		#endregion //Constructor
	}

    public class MyBehavior : Behavior<ContentPane>
    {
        public bool IsActivePane
        {
            get { return (bool)GetValue(IsActivePaneProperty); }
            set { SetValue(IsActivePaneProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsActivePane.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsActivePaneProperty =
            DependencyProperty.Register("IsActivePane", typeof(bool), typeof(MyBehavior), new FrameworkPropertyMetadata(false, OnIsActivePaneChanged)
            {
                BindsTwoWayByDefault = true,
            });

        private static void OnIsActivePaneChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            if ((bool)e.NewValue == true)
                (d as MyBehavior).AssociatedObject.Activate();
        }

        protected override void OnAttached()
        {
            var manager = XamDockManager.GetDockManager(this.AssociatedObject);
            manager.ActivePaneChanged += manager_ActivePaneChanged;
        }
        protected override void OnDetaching()
        {
            var manager = XamDockManager.GetDockManager(this.AssociatedObject);
            manager.ActivePaneChanged -= manager_ActivePaneChanged; base.OnDetaching();
        }

        void manager_ActivePaneChanged(object sender, RoutedPropertyChangedEventArgs<ContentPane> e)
        {
            Console.WriteLine(this.AssociatedObject.IsActivePane.ToString());
            this.IsActivePane = this.AssociatedObject.IsActivePane;
        }
    }
}
